<script setup lang="ts">
import { ref } from 'vue';
import {
  AiMergeRequest,
  AiSummarizeMrReview,
  AiIssue,
  AiGenerateIssueDescription,
  AiValueStreamForecast,
  AiTestsInMr,
  AiVulnerabilityResolution,
  AiVulnerabilityBug,
  AiGitSuggestions,
  AiGitlabChat,
  AiRootCauseAnalysis,
  PackageAlt2,
  SecureAlt2,
  PlanAlt2,
  MonitorAlt2,
  ChevronLgRight,
} from 'slippers-ui/icons';

interface Card {
  header?: string;
  description?: string;
  ctaText?: string;
  config: {
    icon?: string;
    href: string;
  };
}
interface Category {
  name: string;
  cards: Array<Card>;
  config: {
    icon?: string;
    key: string;
  };
}

interface CategoriesProp {
  header: string;
  categories: Array<Category>;
  disclaimer: string;
}

const icons: Component = {
  AiMergeRequest,
  AiSummarizeMrReview,
  AiIssue,
  AiGenerateIssueDescription,
  AiValueStreamForecast,
  AiTestsInMr,
  AiVulnerabilityResolution,
  AiVulnerabilityBug,
  AiGitSuggestions,
  AiGitlabChat,
  AiRootCauseAnalysis,
  PackageAlt2,
  SecureAlt2,
  PlanAlt2,
  MonitorAlt2,
  ChevronLgRight,
};
const props = defineProps<CategoriesProp>();
const activeCategory = ref<Category | null>(null);
const filterFeatures = (key: string) => {
  const activeCategoryArray = props.categories.filter((category) => category.config?.key == key);
  activeCategory.value = activeCategoryArray[0];
};

filterFeatures('developing');
</script>

<template>
  <section class="gitlab-duo-categories slp-pt-96">
    <SlpContainer>
      <SlpTypography
        class="slp-pb-32 gitlab-duo-categories__header"
        variant="heading3-bold"
        tag="h2"
        data-aos="fade-up"
        data-aos-duration="1200"
        data-aos-offset="200"
      >
        {{ header }}
      </SlpTypography>
      <div class="gitlab-duo-categories__container">
        <header class="gitlab-duo-categories__tabs">
          <button
            v-for="category in categories"
            :key="category.config.key"
            class="gitlab-duo-categories__button"
            :class="{ selected: activeCategory?.config.key === category.config?.key }"
            :data-ga-name="`${category.name.toLowerCase()} tab`"
            data-ga-location="features"
            @click="filterFeatures(category.config?.key)"
          >
            <SlpIcon
              v-if="category.config?.icon"
              :icon="icons[category.config?.icon]"
              size="lg"
              class="gitlab-duo-categories__icon"
            />
            {{ category.name }}
          </button>
        </header>
        <div class="gitlab-duo-categories__cards">
          <a
            v-for="item in activeCategory?.cards"
            :key="item.header"
            class="gitlab-duo-categories__card"
            :data-category="activeCategory?.config.key"
            :href="item.config.href"
            :data-ga-name="item?.header?.toLowerCase()"
            data-ga-location="body"
            data-aos="fade-up"
            data-aos-duration="1200"
            data-aos-offset="200"
          >
            <SlpIcon
              v-if="item.config.icon"
              :icon="icons[item.config.icon]"
              size="md"
              class="gitlab-duo-categories__card-icon"
            />

            <SlpTypography class="slp-pt-16" variant="body1-bold" tag="h3">
              {{ item.header }}
            </SlpTypography>
            <SlpTypography class="gitlab-duo-categories__text slp-py-8" variant="body-2" tag="p">
              {{ item.description }}
            </SlpTypography>
            <div class="gitlab-duo-categories__cta">
              {{ item.ctaText }}
              <SlpIcon :icon="ChevronLgRight" />
            </div>
          </a>
        </div>
      </div>
      <div class="gitlab-duo-categories__disclaimer slp-mt-32" v-html="$md.render(disclaimer)" />
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.gitlab-duo-categories {
  background-color: $color-primary-200;
  &__header {
    max-width: 750px;
    color: #fff;
  }
  &__tabs {
    display: flex;
    justify-content: center;

    @media screen and (max-width: 768px) {
      flex-direction: column;
    }
  }
  &__container {
    background: linear-gradient(0deg, rgba(225, 152, 109, 0.1) 0%, rgba(110, 67, 211, 0.1) 100%);
    border: 1px solid $color-surface-600;
    padding: 32px;
    border-radius: 8px;
  }
  &__button {
    color: $color-surface-400;
    padding: $spacing-24 $spacing-32;
    font-size: 16px;
    font-weight: 600;
    line-height: 24px;
    text-align: center;
    cursor: pointer;
    border: none;
    border-bottom: 1px solid $color-surface-600;
    transition:
      color 0.3s ease,
      border-bottom-color 0.3s ease;

    box-shadow: 0 3px 0 0 transparent;
    display: flex;
    flex-direction: column;
    align-items: center;
    gap: 8px;

    &:hover,
    &:focus {
      color: white;
    }
    &.selected {
      box-shadow: 0 2px 0 0 #7759c2;
      color: white;
    }
  }
  &__card {
    color: #fff;
    background: $color-surface-700;
    border-radius: 8px 8px 8px 8px;
    padding: 24px;
    display: flex;
    flex-direction: column;
    transition: all 0.2s ease-in-out;
    .slp-icon {
      margin-left: 4px;
      transition: margin-left 0.2s ease-in-out;
    }
    &:not(:hover) {
      animation: hover-off-animation 0.3s ease forwards;
    }
    &:hover {
      animation: hover-animation 0.3s ease forwards;
      .slp-icon {
        margin-left: 8px;
      }
    }
  }
  &__cards {
    padding-top: 32px;
    display: grid;
    gap: 32px;
    grid-template-columns: 1fr 1fr;
    align-items: stretch;

    @media screen and (max-width: 768px) {
      grid-template-columns: 1fr;
    }
  }
  &__cta {
    display: inline-flex;
    color: #fff;
    font-size: 18px;
    line-height: 20px;
    font-weight: $font-weight-bold;
    align-items: center;
    padding: 11px 0;
  }
  &__text {
    color: $color-surface-400;
    flex-grow: 1;
  }
  &__disclaimer {
    color: $color-surface-400;
    font-size: 14px;
    font-weight: 400;
    line-height: 22px;
    :deep(a) {
      font-weight: 600;
    }
  }
  &__card-icon {
    width: 34px;
    height: 34px;
  }
  &__icon {
    color: #fff;
  }
}
@keyframes hover-animation {
  0% {
    border-radius: 8px 8px 8px 8px;
  }
  100% {
    border-radius: 8px 8px 80px 8px;
  }
}

@keyframes hover-off-animation {
  0% {
    border-radius: 8px 8px 80px 8px;
  }
  100% {
    border-radius: 8px 8px 8px 8px;
  }
}
</style>
